#include <stdio.h>

extern void ex_add(int bytes, unsigned char *a, unsigned char *b, unsigned char *c);
int getLength();
int getInteger();
void getValue(int bytes, unsigned char *a);
void printValue(int bytes, unsigned char *a);

int main(){
  puts("** ComSys Report 2-B : 2005/12/07(Thu) **");
  puts("[450318C Sho Iwamoto]\n");

  int l = getLength();
 
  unsigned char a[l],b[l],c[l];

  printf("\nPlease input two-values.\n");
  printf("[if started with '0x', calculated as unsigned hexadecimal.]\n\n");
  
  printf("Num-1\n"); getValue(l,a);
  printf("Num-2\n"); getValue(l,b);

  ex_add(l, a, b, c);

  printf("\n  a = "); printValue(l,a);
  printf("  b = "); printValue(l,b);
  printf("a+b = "); printValue(l,c);

  puts("\n** END **\n");

  return 0;
}

int getLength(){
  int i=0;
  printf("Bytes\n");
  while(i<1){
    i = getInteger();
  }
  return i;
}

int getInteger(){
  int l;
  char str[12];
  printf("? ");
  do{
    fgets(str,12,stdin);
    l = strlen(str);
    if(str[l-1]=='\n') str[(l--)-1] = '\0';
  } while(l<1);
  return atoi(str);
}

void getValue(int bytes, unsigned char *a){
  unsigned char c;
  char str[(int)(bytes*2.5)+4];
  int z[bytes];
  int i,j,l,f,r,dflag = 0,offlag=0;
  do{
    // ------------------------------ get String
    f = 0;
    printf(" -> ");
    do{
      fgets(str,(int)(bytes*2.5)+4,stdin);
      l = strlen(str);
      if(str[l-1]=='\n') str[(l--)-1] = '\0';
    } while(l<1);
    // ------------------------------ convert
    if(str[0]=='0' && str[1]=='x'){
      // hexadecimal
      if(l>bytes*2+2){
	l=bytes*2+2;
	offlag = 1;
      }
      dflag = 2-l%2;
      for(i = l%2; i < l-dflag; i++){
	str[i] = toupper(str[i+dflag]);
	if     (offlag==1) str[i]=15;
	else if(47<str[i] && str[i]<58) str[i] -= 48;
	else if(64<str[i] && str[i]<71) str[i] -= 55;
	else { f=1; break; }
      }
      l = (l - dflag)/2;
    }else{
      // decimal
      for(i=0; i<l; i++){
	if     (47<str[i] && str[i]<58) str[i] -= 48;
	else { f=1; break; }
      }
    }	
  } while(f==1);
  
  // ------------------------------ insert
  if(dflag>0){
    // hexadecimal
    for(i=0; i<l && i<bytes; i++){
      *(a+bytes-i-1) = str[(l-i)*2-2]*16 + str[(l-i)*2-1];
    }
    for(i=0;i<bytes-l;i++){
      *(a+i)=0;
    }
  }else{
    for(i=bytes-1;i>=0;i--){ z[i]=0; }
    for(j=0;j<l;j++){
      r = str[j];
      for(i=bytes-1;i>=0;i--){
	z[i]=z[i]*10+r;
	r=z[i]>>8;
	z[i]=z[i] & 0xff;
      }
    }
    if(r>0){
      for(i=bytes-1;i>=0;i--) a[i]=255;
    }else{
      for(i=bytes-1;i>=0;i--) a[i]=z[i];
    }
  }
  return;
}



void printValue(int bytes, unsigned char *a){
  int i;
  unsigned char c;
  for(i = 0; i < bytes; i++){
    c = (*(a+i) >> 4);
    if(c < 0xa){
      c = c + 0x30;
    }else{
      c = c + 0x37;
    }
    printf("%c", c);
    
    c = (*(a+i) & 0x0f);
    if(c < 0xa){
      c = c + 0x30;
    }else{
      c = c + 0x37;
    }
    printf("%c", c);
  }
  printf("\n");
  return;
}
